#include <cstring>
#include "smat.h"

void exit_with_help() {
	printf(
	"Usage: converter data_dir\n"
	);
	exit(1);
}

int main(int argc, char* argv[]){
	if(argc != 2) exit_with_help();
	size_t m, n, nnz;
	char filename[1024], buf[1024];
	char *srcdir = argv[1];
	FILE *fp; 
	sprintf(filename,"%s/meta",srcdir);
	fp = fopen(filename,"r");
	if(fscanf(fp, "%lu %lu", &m, &n) != 2) {
		fprintf(stderr, "Error: corrupted meta in line 1 of %s\n", srcdir);
		return 1;
	}

	if(fscanf(fp, "%lu %s", &nnz, buf) != 2) {
		fprintf(stderr, "Error: corrupted meta in line 2 of %s\n", srcdir);
		return 1;
	}
	sprintf(filename,"%s/%s", srcdir, buf);
	smat_t training_set;
	training_set.load(m, n, nnz, filename, smat_t::TXT);
	printf("%s: m %ld n %ld nnz %ld\n", filename, training_set.rows, training_set.cols, training_set.nnz);
	sprintf(filename,"%s/%s.petsc", srcdir, buf);
	training_set.save_PETSc_to_file(filename);

	if(fscanf(fp, "%lu %s", &nnz, buf) != EOF){
		sprintf(filename,"%s/%s", srcdir, buf);
		smat_t test_set;
		test_set.load(m, n, nnz, filename, smat_t::TXT);
		printf("%s: m %ld n %ld nnz %ld\n", filename, test_set.rows, test_set.cols, test_set.nnz);
		sprintf(filename,"%s/%s.petsc", srcdir, buf);
		test_set.save_PETSc_to_file(filename);
	}

	return 0;
}

